if (!defined &_ASM_SPARC_DMA_H) {
    eval 'sub _ASM_SPARC_DMA_H {1;}';
    require 'linux/kernel.ph';
    require 'asm/vac-ops.ph';
    require 'asm/sbus.ph';
    require 'asm/delay.ph';
    require 'asm/oplib.ph';
    eval 'sub MAX_DMA_CHANNELS {8;}';
    eval 'sub MAX_DMA_ADDRESS {(~0);}';
    eval 'sub DMA_MODE_READ {1;}';
    eval 'sub DMA_MODE_WRITE {2;}';
    eval 'sub SIZE_16MB {(16*1024*1024);}';
    eval 'sub SIZE_64K {(64*1024);}';
    eval 'sub DMA_HASCOUNT {
        local($rev) = @_;
        eval "(($rev)== &dvmaesc1)";
    }';
    eval 'sub DMA_ISBROKEN {
        local($dma) = @_;
        eval "(($dma)-> &revision ==  &dvmarev1)";
    }';
    eval 'sub DMA_ISESC1 {
        local($dma) = @_;
        eval "(($dma)-> &revision ==  &dvmaesc1)";
    }';
    eval 'sub DMA_DEVICE_ID {0xf0000000;}';
    eval 'sub DMA_VERS0 {0x00000000;}';
    eval 'sub DMA_ESCV1 {0x40000000;}';
    eval 'sub DMA_VERS1 {0x80000000;}';
    eval 'sub DMA_VERS2 {0xa0000000;}';
    eval 'sub DMA_VERHME {0xb0000000;}';
    eval 'sub DMA_VERSPLUS {0x90000000;}';
    eval 'sub DMA_HNDL_INTR {0x00000001;}';
    eval 'sub DMA_HNDL_ERROR {0x00000002;}';
    eval 'sub DMA_FIFO_ISDRAIN {0x0000000c;}';
    eval 'sub DMA_INT_ENAB {0x00000010;}';
    eval 'sub DMA_FIFO_INV {0x00000020;}';
    eval 'sub DMA_ACC_SZ_ERR {0x00000040;}';
    eval 'sub DMA_FIFO_STDRAIN {0x00000040;}';
    eval 'sub DMA_RST_SCSI {0x00000080;}';
    eval 'sub DMA_RST_ENET { &DMA_RST_SCSI;}';
    eval 'sub DMA_ST_WRITE {0x00000100;}';
    eval 'sub DMA_ENABLE {0x00000200;}';
    eval 'sub DMA_PEND_READ {0x00000400;}';
    eval 'sub DMA_ESC_BURST {0x00000800;}';
    eval 'sub DMA_READ_AHEAD {0x00001800;}';
    eval 'sub DMA_DSBL_RD_DRN {0x00001000;}';
    eval 'sub DMA_BCNT_ENAB {0x00002000;}';
    eval 'sub DMA_TERM_CNTR {0x00004000;}';
    eval 'sub DMA_CSR_DISAB {0x00010000;}';
    eval 'sub DMA_SCSI_DISAB {0x00020000;}';
    eval 'sub DMA_DSBL_WR_INV {0x00020000;}';
    eval 'sub DMA_ADD_ENABLE {0x00040000;}';
    eval 'sub DMA_E_BURST8 {0x00040000;}';
    eval 'sub DMA_BRST_SZ {0x000c0000;}';
    eval 'sub DMA_BRST64 {0x00080000;}';
    eval 'sub DMA_BRST32 {0x00040000;}';
    eval 'sub DMA_BRST16 {0x00000000;}';
    eval 'sub DMA_BRST0 {0x00080000;}';
    eval 'sub DMA_ADDR_DISAB {0x00100000;}';
    eval 'sub DMA_2CLKS {0x00200000;}';
    eval 'sub DMA_3CLKS {0x00400000;}';
    eval 'sub DMA_EN_ENETAUI { &DMA_3CLKS;}';
    eval 'sub DMA_CNTR_DISAB {0x00800000;}';
    eval 'sub DMA_AUTO_NADDR {0x01000000;}';
    eval 'sub DMA_SCSI_ON {0x02000000;}';
    eval 'sub DMA_PARITY_OFF {0x02000000;}';
    eval 'sub DMA_LOADED_ADDR {0x04000000;}';
    eval 'sub DMA_LOADED_NADDR {0x08000000;}';
    eval 'sub DMA_BURST1 {0x01;}';
    eval 'sub DMA_BURST2 {0x02;}';
    eval 'sub DMA_BURST4 {0x04;}';
    eval 'sub DMA_BURST8 {0x08;}';
    eval 'sub DMA_BURST16 {0x10;}';
    eval 'sub DMA_BURST32 {0x20;}';
    eval 'sub DMA_BURST64 {0x40;}';
    eval 'sub DMA_BURSTBITS {0x7f;}';
    eval 'sub DMA_MAXEND {
        local($addr) = @_;
        eval "(0x01000000 &UL-((($addr))&0x00ffffff &UL))";
    }';
    eval 'sub DMA_ERROR_P {
        local($regs) = @_;
        eval "(((($regs)-> &cond_reg) &  &DMA_HNDL_ERROR))";
    }';
    eval 'sub DMA_IRQ_P {
        local($regs) = @_;
        eval "(((($regs)-> &cond_reg) & ( &DMA_HNDL_INTR |  &DMA_HNDL_ERROR)))";
    }';
    eval 'sub DMA_WRITE_P {
        local($regs) = @_;
        eval "(((($regs)-> &cond_reg) &  &DMA_ST_WRITE))";
    }';
    eval 'sub DMA_OFF {
        local($regs) = @_;
        eval "(((($regs)-> &cond_reg) &= (~ &DMA_ENABLE)))";
    }';
    eval 'sub DMA_INTSOFF {
        local($regs) = @_;
        eval "(((($regs)-> &cond_reg) &= (~ &DMA_INT_ENAB)))";
    }';
    eval 'sub DMA_INTSON {
        local($regs) = @_;
        eval "(((($regs)-> &cond_reg) |= ( &DMA_INT_ENAB)))";
    }';
    eval 'sub DMA_PUNTFIFO {
        local($regs) = @_;
        eval "(((($regs)-> &cond_reg) |=  &DMA_FIFO_INV))";
    }';
    eval 'sub DMA_SETSTART {
        local($regs, $addr) = @_;
        eval "(((($regs)-> &st_addr) =  $addr))";
    }';
    eval 'sub DMA_BEGINDMA_W {
        local($regs) = @_;
        eval "(((($regs)-> &cond_reg |= ( &DMA_ST_WRITE| &DMA_ENABLE| &DMA_INT_ENAB))))";
    }';
    eval 'sub DMA_BEGINDMA_R {
        local($regs) = @_;
        eval "(((($regs)-> &cond_reg |= (( &DMA_ENABLE| &DMA_INT_ENAB)&(~ &DMA_ST_WRITE)))))";
    }';
    eval 'sub DMA_IRQ_ENTRY {
        local($dma, $dregs) = @_;
        eval " &do {  &if( &DMA_ISBROKEN($dma))  &DMA_INTSOFF($dregs); }  &while (0)";
    }';
    eval 'sub DMA_IRQ_EXIT {
        local($dma, $dregs) = @_;
        eval " &do {  &if( &DMA_ISBROKEN($dma))  &DMA_INTSON($dregs); }  &while(0)";
    }';
    eval 'sub DMA_RESET {
        local($dma) = @_;
        eval " &do { \'struct sparc_dma_registers\' * &regs = $dma-> &regs;  &sparc_dma_pause( &regs, ( &DMA_FIFO_ISDRAIN));  &regs-> &cond_reg |= ( &DMA_RST_SCSI);  &__delay(400);  &regs-> &cond_reg &= ~( &DMA_RST_SCSI);  &sparc_dma_enable_interrupts( &regs);  &if($dma-> &revision> &dvmarev1)  &regs-> &cond_reg |=  &DMA_3CLKS; $dma-> &running = 0; }  &while(0)";
    }';
    eval 'sub for_each_dvma {
        local($dma) = @_;
        eval " &for(($dma) =  &dma_chain; ($dma); ($dma) = ($dma)-> &next)";
    }';
}
1;
