if (!defined &_SPARC_WINMACRO_H) {
    eval 'sub _SPARC_WINMACRO_H {1;}';
    require 'asm/ptrace.ph';
    require 'asm/psr.ph';
    eval 'sub _SV { &save % &sp, - &REGWIN_SZ, % &sp;}';
    eval 'sub _RS { &restore;}';
    eval 'sub FLUSH_ALL_KERNEL_WINDOWS { &_SV;  &_SV;  &_SV;  &_SV;  &_SV;  &_SV;  &_SV;  &_RS;  &_RS;  &_RS;  &_RS;  &_RS;  &_RS;  &_RS;;}';
    eval 'sub STORE_WINDOW {
        local($reg) = @_;
        eval " &std % &l0, [%$reg +  &RW_L0];  &std % &l2, [%$reg +  &RW_L2];  &std % &l4, [%$reg +  &RW_L4];  &std % &l6, [%$reg +  &RW_L6];  &std % &i0, [%$reg +  &RW_I0];  &std % &i2, [%$reg +  &RW_I2];  &std % &i4, [%$reg +  &RW_I4];  &std % &i6, [%$reg +  &RW_I6];";
    }';
    eval 'sub LOAD_WINDOW {
        local($reg) = @_;
        eval " &ldd [%$reg +  &RW_L0], % &l0;  &ldd [%$reg +  &RW_L2], % &l2;  &ldd [%$reg +  &RW_L4], % &l4;  &ldd [%$reg +  &RW_L6], % &l6;  &ldd [%$reg +  &RW_I0], % &i0;  &ldd [%$reg +  &RW_I2], % &i2;  &ldd [%$reg +  &RW_I4], % &i4;  &ldd [%$reg +  &RW_I6], % &i6;";
    }';
    eval 'sub LOAD_PT_INS {
        local($base_reg) = @_;
        eval " &ldd [%$base_reg +  &REGWIN_SZ +  &PT_I0], % &i0;  &ldd [%$base_reg +  &REGWIN_SZ +  &PT_I2], % &i2;  &ldd [%$base_reg +  &REGWIN_SZ +  &PT_I4], % &i4;  &ldd [%$base_reg +  &REGWIN_SZ +  &PT_I6], % &i6;";
    }';
    eval 'sub LOAD_PT_GLOBALS {
        local($base_reg) = @_;
        eval " &ld [%$base_reg +  &REGWIN_SZ +  &PT_G1], % &g1;  &ldd [%$base_reg +  &REGWIN_SZ +  &PT_G2], % &g2;  &ldd [%$base_reg +  &REGWIN_SZ +  &PT_G4], % &g4;  &ldd [%$base_reg +  &REGWIN_SZ +  &PT_G6], % &g6;";
    }';
    eval 'sub LOAD_PT_YREG {
        local($base_reg, $scratch) = @_;
        eval " &ld [%$base_reg +  &REGWIN_SZ +  &PT_Y], %$scratch;  &wr %$scratch, 0x0, % &y;";
    }';
    eval 'sub LOAD_PT_PRIV {
        local($base_reg, $pt_psr, $pt_pc, $pt_npc) = @_;
        eval " &ld [%$base_reg +  &REGWIN_SZ +  &PT_PSR], %$pt_psr;  &ld [%$base_reg +  &REGWIN_SZ +  &PT_PC], %$pt_pc;  &ld [%$base_reg +  &REGWIN_SZ +  &PT_NPC], %$pt_npc;";
    }';
    eval 'sub LOAD_PT_ALL {
        local($base_reg, $pt_psr, $pt_pc, $pt_npc, $scratch) = @_;
        eval " &LOAD_PT_YREG($base_reg, $scratch)  &LOAD_PT_INS($base_reg)  &LOAD_PT_GLOBALS($base_reg)  &LOAD_PT_PRIV($base_reg, $pt_psr, $pt_pc, $pt_npc)";
    }';
    eval 'sub STORE_PT_INS {
        local($base_reg) = @_;
        eval " &std % &i0, [%$base_reg +  &REGWIN_SZ +  &PT_I0];  &std % &i2, [%$base_reg +  &REGWIN_SZ +  &PT_I2];  &std % &i4, [%$base_reg +  &REGWIN_SZ +  &PT_I4];  &std % &i6, [%$base_reg +  &REGWIN_SZ +  &PT_I6];";
    }';
    eval 'sub STORE_PT_GLOBALS {
        local($base_reg) = @_;
        eval " &st % &g1, [%$base_reg +  &REGWIN_SZ +  &PT_G1];  &std % &g2, [%$base_reg +  &REGWIN_SZ +  &PT_G2];  &std % &g4, [%$base_reg +  &REGWIN_SZ +  &PT_G4];  &std % &g6, [%$base_reg +  &REGWIN_SZ +  &PT_G6];";
    }';
    eval 'sub STORE_PT_YREG {
        local($base_reg, $scratch) = @_;
        eval " &rd % &y, %$scratch;  &st %$scratch, [%$base_reg +  &REGWIN_SZ +  &PT_Y];";
    }';
    eval 'sub STORE_PT_PRIV {
        local($base_reg, $pt_psr, $pt_pc, $pt_npc) = @_;
        eval " &st %$pt_psr, [%$base_reg +  &REGWIN_SZ +  &PT_PSR];  &st %$pt_pc, [%$base_reg +  &REGWIN_SZ +  &PT_PC];  &st %$pt_npc, [%$base_reg +  &REGWIN_SZ +  &PT_NPC];";
    }';
    eval 'sub STORE_PT_ALL {
        local($base_reg, $reg_psr, $reg_pc, $reg_npc, $g_scratch) = @_;
        eval " &STORE_PT_PRIV($base_reg, $reg_psr, $reg_pc, $reg_npc)  &STORE_PT_GLOBALS($base_reg)  &STORE_PT_YREG($base_reg, $g_scratch)  &STORE_PT_INS($base_reg)";
    }';
    eval 'sub SAVE_BOLIXED_USER_STACK {
        local($cur_reg, $scratch) = @_;
        eval " &ld [%$cur_reg +  &THREAD_W_SAVED], %$scratch;  &sll %$scratch, 2, %$scratch;  &add %$scratch, %$cur_reg, %$scratch;  &st % &sp, [%$scratch +  &THREAD_STACK_PTRS];  &sub %$scratch, %$cur_reg, %$scratch;  &sll %$scratch, 4, %$scratch;  &add %$scratch, %$cur_reg, %$scratch;  &STORE_WINDOW($scratch +  &THREAD_REG_WINDOW);  &sub %$scratch, %$cur_reg, %$scratch;  &srl %$scratch, 6, %$scratch;  &add %$scratch, 1, %$scratch;  &st %$scratch, [%$cur_reg +  &THREAD_W_SAVED];";
    }';
    if (defined &__SMP__) {
	eval 'sub LOAD_CURRENT {
	    local($dest_reg, $idreg) = @_;
	    eval " &rd % &tbr, %$idreg;  &srl %$idreg, 10, %$idreg;  &and %$idreg, 0xc, %$idreg;  &sethi % &hi( &C_LABEL( &current_set)), %$dest_reg;  &or %$dest_reg, % &lo( &C_LABEL( &current_set)), %$dest_reg;  &add %$dest_reg, %$idreg, %$idreg;  &ld [%$idreg], %$dest_reg;";
	}';
    }
    else {
	eval 'sub LOAD_CURRENT {
	    local($dest_reg, $idreg) = @_;
	    eval " &sethi % &hi( &C_LABEL( &current_set)), %$idreg;  &ld [%$idreg + % &lo( &C_LABEL( &current_set))], %$dest_reg;";
	}';
    }
}
1;
