if (!defined &AMIGAFFS_H) {
    eval 'sub AMIGAFFS_H {1;}';
    require 'asm/byteorder.ph';
    require 'linux/types.ph';
    eval 'sub GET_END_PTR {
        local($st,$p,$sz) = @_;
        eval "(($st *)(($p)+(($sz)-$sizeof{$st})))";
    }';
    eval 'sub AFFS_GET_HASHENTRY {
        local($data,$hashkey) = @_;
        eval " &htonl(($data)-> $hashtable[$hashkey])";
    }';
    eval 'sub AFFS_BLOCK {
        local($data,$ino,$blk) = @_;
        eval "($data)-> $blocks[ &AFFS_I2HSIZE($ino)-1-($blk)]";
    }';
    eval 'sub FILE_END {
        local($p,$i) = @_;
        eval " &GET_END_PTR(\'struct file_end\',$p, &AFFS_I2BSIZE($i))";
    }';
    eval 'sub ROOT_END {
        local($p,$i) = @_;
        eval " &GET_END_PTR(\'struct root_end\',$p, &AFFS_I2BSIZE($i))";
    }';
    eval 'sub DIR_END {
        local($p,$i) = @_;
        eval " &GET_END_PTR(\'struct dir_end\',$p, &AFFS_I2BSIZE($i))";
    }';
    eval 'sub LINK_END {
        local($p,$i) = @_;
        eval " &GET_END_PTR(\'struct hlink_end\',$p, &AFFS_I2BSIZE($i))";
    }';
    eval 'sub ROOT_END_S {
        local($p,$s) = @_;
        eval " &GET_END_PTR(\'struct root_end\',$p,($s)-> &s_blocksize)";
    }';
    eval 'sub DATA_FRONT {
        local($bh) = @_;
        eval "(($bh)-> &b_data)";
    }';
    eval 'sub affs_bread { &bread;}';
    eval 'sub affs_brelse { &brelse;}';
    if (defined &__LITTLE_ENDIAN) {
	eval 'sub BO_EXBITS {0x18 &UL;}';
    }
    elsif (defined( &__BIG_ENDIAN)) {
	eval 'sub BO_EXBITS {0x00 &UL;}';
    }
    else {
    }
    eval 'sub FS_OFS {0x444F5300;}';
    eval 'sub FS_FFS {0x444F5301;}';
    eval 'sub FS_INTLOFS {0x444F5302;}';
    eval 'sub FS_INTLFFS {0x444F5303;}';
    eval 'sub FS_DCOFS {0x444F5304;}';
    eval 'sub FS_DCFFS {0x444F5305;}';
    eval 'sub MUFS_FS {0x6d754653;}';
    eval 'sub MUFS_OFS {0x6d754600;}';
    eval 'sub MUFS_FFS {0x6d754601;}';
    eval 'sub MUFS_INTLOFS {0x6d754602;}';
    eval 'sub MUFS_INTLFFS {0x6d754603;}';
    eval 'sub MUFS_DCOFS {0x6d754604;}';
    eval 'sub MUFS_DCFFS {0x6d754605;}';
    eval 'sub T_SHORT {2;}';
    eval 'sub T_LIST {16;}';
    eval 'sub T_DATA {8;}';
    eval 'sub ST_LINKFILE {-4;}';
    eval 'sub ST_FILE {-3;}';
    eval 'sub ST_ROOT {1;}';
    eval 'sub ST_USERDIR {2;}';
    eval 'sub ST_SOFTLINK {3;}';
    eval 'sub ST_LINKDIR {4;}';
    eval 'sub FIBF_OTR_READ {0x8000;}';
    eval 'sub FIBF_OTR_WRITE {0x4000;}';
    eval 'sub FIBF_OTR_EXECUTE {0x2000;}';
    eval 'sub FIBF_OTR_DELETE {0x1000;}';
    eval 'sub FIBF_GRP_READ {0x0800;}';
    eval 'sub FIBF_GRP_WRITE {0x0400;}';
    eval 'sub FIBF_GRP_EXECUTE {0x0200;}';
    eval 'sub FIBF_GRP_DELETE {0x0100;}';
    eval 'sub FIBF_SCRIPT {0x0040;}';
    eval 'sub FIBF_PURE {0x0020;}';
    eval 'sub FIBF_ARCHIVE {0x0010;}';
    eval 'sub FIBF_READ {0x0008;}';
    eval 'sub FIBF_WRITE {0x0004;}';
    eval 'sub FIBF_EXECUTE {0x0002;}';
    eval 'sub FIBF_DELETE {0x0001;}';
    eval 'sub FIBF_OWNER {0x000F;}';
    eval 'sub AFFS_UMAYWRITE {
        local($prot) = @_;
        eval "((($prot) & ( &FIBF_WRITE| &FIBF_DELETE)) == ( &FIBF_WRITE| &FIBF_DELETE))";
    }';
    eval 'sub AFFS_UMAYREAD {
        local($prot) = @_;
        eval "(($prot) &  &FIBF_READ)";
    }';
    eval 'sub AFFS_UMAYEXECUTE {
        local($prot) = @_;
        eval "((($prot) & ( &FIBF_SCRIPT| &FIBF_READ)) == ( &FIBF_SCRIPT| &FIBF_READ))";
    }';
    eval 'sub AFFS_GMAYWRITE {
        local($prot) = @_;
        eval "((($prot)&( &FIBF_GRP_WRITE| &FIBF_GRP_DELETE))== ( &FIBF_GRP_WRITE| &FIBF_GRP_DELETE))";
    }';
    eval 'sub AFFS_GMAYREAD {
        local($prot) = @_;
        eval "(($prot) &  &FIBF_GRP_READ)";
    }';
    eval 'sub AFFS_GMAYEXECUTE {
        local($prot) = @_;
        eval "((($prot)&( &FIBF_SCRIPT| &FIBF_GRP_READ))==( &FIBF_SCRIPT| &FIBF_GRP_READ))";
    }';
    eval 'sub AFFS_OMAYWRITE {
        local($prot) = @_;
        eval "((($prot)&( &FIBF_OTR_WRITE| &FIBF_OTR_DELETE))== ( &FIBF_OTR_WRITE| &FIBF_OTR_DELETE))";
    }';
    eval 'sub AFFS_OMAYREAD {
        local($prot) = @_;
        eval "(($prot) &  &FIBF_OTR_READ)";
    }';
    eval 'sub AFFS_OMAYEXECUTE {
        local($prot) = @_;
        eval "((($prot)&( &FIBF_SCRIPT| &FIBF_OTR_READ))==( &FIBF_SCRIPT| &FIBF_OTR_READ))";
    }';
}
1;
