if (!defined &LINUX_CM206_H) {
    eval 'sub LINUX_CM206_H {1;}';
    require 'linux/ioctl.ph';
    eval 'sub CM206_BASE {0x340;}';
    eval 'sub CM206_IRQ {11;}';
    eval 'sub r_data_status {( &cm206_base);}';
    eval 'sub r_uart_receive {( &cm206_base+0x2);}';
    eval 'sub r_fifo_output_buffer {( &cm206_base+0x4);}';
    eval 'sub r_line_status {( &cm206_base+0x6);}';
    eval 'sub r_data_control {( &cm206_base+0x8);}';
    eval 'sub r_uart_transmit {( &cm206_base+0xa);}';
    eval 'sub r_test_clock {( &cm206_base+0xc);}';
    eval 'sub r_test_control {( &cm206_base+0xe);}';
    eval 'sub ds_ram_size {0x4000;}';
    eval 'sub ds_toc_ready {0x2000;}';
    eval 'sub ds_fifo_empty {0x1000;}';
    eval 'sub ds_sync_error {0x800;}';
    eval 'sub ds_crc_error {0x400;}';
    eval 'sub ds_data_error {0x200;}';
    eval 'sub ds_fifo_overflow {0x100;}';
    eval 'sub ds_data_ready {0x80;}';
    eval 'sub ls_attention {0x10;}';
    eval 'sub ls_parity_error {0x8;}';
    eval 'sub ls_overrun {0x4;}';
    eval 'sub ls_receive_buffer_full {0x2;}';
    eval 'sub ls_transmitter_buffer_empty {0x1;}';
    eval 'sub dc_read_q_channel {0x4000;}';
    eval 'sub dc_mask_sync_error {0x2000;}';
    eval 'sub dc_toc_enable {0x1000;}';
    eval 'sub dc_no_stop_on_error {0x800;}';
    eval 'sub dc_break {0x400;}';
    eval 'sub dc_initialize {0x200;}';
    eval 'sub dc_mask_transmit_ready {0x100;}';
    eval 'sub dc_flag_enable {0x80;}';
    eval 'sub dc_normal {( &dc_mask_sync_error |  &dc_no_stop_on_error |  &dc_mask_transmit_ready);}';
    eval 'sub dsb_error_condition {0x1;}';
    eval 'sub dsb_play_in_progress {0x4;}';
    eval 'sub dsb_possible_media_change {0x8;}';
    eval 'sub dsb_disc_present {0x10;}';
    eval 'sub dsb_drive_not_ready {0x20;}';
    eval 'sub dsb_tray_locked {0x40;}';
    eval 'sub dsb_tray_not_closed {0x80;}';
    eval 'sub dsb_not_useful {( &dsb_drive_not_ready |  &dsb_tray_not_closed);}';
    eval 'sub c_close_tray {0;}';
    eval 'sub c_lock_tray {0x01;}';
    eval 'sub c_unlock_tray {0x04;}';
    eval 'sub c_open_tray {0x05;}';
    eval 'sub c_seek {0x10;}';
    eval 'sub c_read_data {0x20;}';
    eval 'sub c_force_1x {0x21;}';
    eval 'sub c_force_2x {0x22;}';
    eval 'sub c_auto_mode {0x23;}';
    eval 'sub c_play {0x30;}';
    eval 'sub c_set_audio_mode {0x31;}';
    eval 'sub c_read_current_q {0x41;}';
    eval 'sub c_stream_q {0x42;}';
    eval 'sub c_drive_status {0x50;}';
    eval 'sub c_disc_status {0x51;}';
    eval 'sub c_audio_status {0x52;}';
    eval 'sub c_drive_configuration {0x53;}';
    eval 'sub c_read_upc {0x60;}';
    eval 'sub c_stop {0x70;}';
    eval 'sub c_calc_checksum {0xe5;}';
    eval 'sub c_gimme {0xf8;}';
    eval 'sub e_none {0;}';
    eval 'sub e_illegal_command {0x01;}';
    eval 'sub e_sync {0x02;}';
    eval 'sub e_seek {0x03;}';
    eval 'sub e_parity {0x04;}';
    eval 'sub e_focus {0x05;}';
    eval 'sub e_header_sync {0x06;}';
    eval 'sub e_code_incompatibility {0x07;}';
    eval 'sub e_reset_done {0x08;}';
    eval 'sub e_bad_parameter {0x09;}';
    eval 'sub e_radial {0x0a;}';
    eval 'sub e_sub_code {0x0b;}';
    eval 'sub e_no_data_track {0x0c;}';
    eval 'sub e_scan {0x0d;}';
    eval 'sub e_tray_open {0x0f;}';
    eval 'sub e_no_disc {0x10;}';
    eval 'sub e_tray { &stalled 0x11;}';
    eval 'sub dcf_revision_code {0x7;}';
    eval 'sub dcf_transfer_rate {0x60;}';
    eval 'sub dcf_motorized_tray {0x80;}';
    eval 'sub cds_multi_session {0x2;}';
    eval 'sub cds_all_audio {0x8;}';
    eval 'sub cds_xa_mode {0xf0;}';
    eval 'sub CM206CTL_GET_STAT { &_IO( 0x20, 0 );}';
    eval 'sub CM206CTL_GET_LAST_STAT { &_IO( 0x20, 1 );}';
    if (!defined( &CDROM_GET_UPC)) {
	eval 'sub CDROM_GET_UPC { &_IO( ord(\'S\'), 0x11 );}';
	eval 'sub CDROMRESET { &_IO( ord(\'S\'), 0x12 );}';
    }
    if (defined &STATISTICS) {
	if (defined &__KERNEL__) {
	    eval 'sub x {
	        local($a) = @_;
	        eval " &st_  $a";
	    }';
	    eval 'sub y { &enum;}';
	}
	else {
	    eval 'sub x {
	        local($a) = @_;
	        eval "$a";
	    }';
	    eval 'sub y {\'char\' *  $stats_name[] =;}';
	}
	if (defined &__KERNEL__) {
	}
	if (defined &__KERNEL__) {
	    eval 'sub NR_STATS { &st_last_entry;}';
	}
	else {
	    eval 'sub NR_STATS {($sizeof{ &stats_name}/$sizeof{\'char\'*});}';
	}
    }
}
1;
