if (!defined &_LINUX_EXT2_FS_H) {
    eval 'sub _LINUX_EXT2_FS_H {1;}';
    require 'linux/types.ph';
    eval 'sub EXT2_PREALLOCATE {1;}';
    eval 'sub EXT2FS_DATE {"95/08/09";}';
    eval 'sub EXT2FS_VERSION {"0.5b";}';
    if (defined &EXT2FS_DEBUG) {
	eval 'sub ext2_debug {( &f,  &a...) {  &printk ("EXT2-fs DEBUG (%s, %d): %s:",  &__FILE__,  &__LINE__,  &__FUNCTION__);  &printk ( &f,   &a); };}';
    }
    else {
	eval 'sub ext2_debug {( &f,  &a...);}';
    }
    eval 'sub EXT2_BAD_INO {1;}';
    eval 'sub EXT2_ROOT_INO {2;}';
    eval 'sub EXT2_ACL_IDX_INO {3;}';
    eval 'sub EXT2_ACL_DATA_INO {4;}';
    eval 'sub EXT2_BOOT_LOADER_INO {5;}';
    eval 'sub EXT2_UNDEL_DIR_INO {6;}';
    eval 'sub EXT2_GOOD_OLD_FIRST_INO {11;}';
    eval 'sub EXT2_SUPER_MAGIC {0xEF53;}';
    eval 'sub EXT2_LINK_MAX {32000;}';
    eval 'sub EXT2_MIN_BLOCK_SIZE {1024;}';
    eval 'sub EXT2_MAX_BLOCK_SIZE {4096;}';
    eval 'sub EXT2_MIN_BLOCK_LOG_SIZE {10;}';
    if (defined &__KERNEL__) {
	eval 'sub EXT2_BLOCK_SIZE {
	    local($s) = @_;
	    eval "(($s)-> &s_blocksize)";
	}';
    }
    else {
	eval 'sub EXT2_BLOCK_SIZE {
	    local($s) = @_;
	    eval "( &EXT2_MIN_BLOCK_SIZE << ($s)-> &s_log_block_size)";
	}';
    }
    eval 'sub EXT2_ACLE_PER_BLOCK {
        local($s) = @_;
        eval "( &EXT2_BLOCK_SIZE($s) / $sizeof{\'struct ext2_acl_entry\'})";
    }';
    eval 'sub EXT2_ADDR_PER_BLOCK {
        local($s) = @_;
        eval "( &EXT2_BLOCK_SIZE($s) / $sizeof{ &__u32})";
    }';
    if (defined &__KERNEL__) {
	eval 'sub EXT2_BLOCK_SIZE_BITS {
	    local($s) = @_;
	    eval "(($s)-> &s_blocksize_bits)";
	}';
    }
    else {
	eval 'sub EXT2_BLOCK_SIZE_BITS {
	    local($s) = @_;
	    eval "(($s)-> &s_log_block_size + 10)";
	}';
    }
    if (defined &__KERNEL__) {
	eval 'sub EXT2_ADDR_PER_BLOCK_BITS {
	    local($s) = @_;
	    eval "(($s)-> &u. &ext2_sb. &s_addr_per_block_bits)";
	}';
	eval 'sub EXT2_INODE_SIZE {
	    local($s) = @_;
	    eval "(($s)-> &u. &ext2_sb. &s_inode_size)";
	}';
	eval 'sub EXT2_FIRST_INO {
	    local($s) = @_;
	    eval "(($s)-> &u. &ext2_sb. &s_first_ino)";
	}';
    }
    else {
	eval 'sub EXT2_INODE_SIZE {
	    local($s) = @_;
	    eval "((($s)-> &s_rev_level ==  &EXT2_GOOD_OLD_REV) ?  &EXT2_GOOD_OLD_INODE_SIZE : ($s)-> &s_inode_size)";
	}';
	eval 'sub EXT2_FIRST_INO {
	    local($s) = @_;
	    eval "((($s)-> &s_rev_level ==  &EXT2_GOOD_OLD_REV) ?  &EXT2_GOOD_OLD_FIRST_INO : ($s)-> &s_first_ino)";
	}';
    }
    eval 'sub EXT2_MIN_FRAG_SIZE {1024;}';
    eval 'sub EXT2_MAX_FRAG_SIZE {4096;}';
    eval 'sub EXT2_MIN_FRAG_LOG_SIZE {10;}';
    if (defined &__KERNEL__) {
	eval 'sub EXT2_FRAG_SIZE {
	    local($s) = @_;
	    eval "(($s)-> &u. &ext2_sb. &s_frag_size)";
	}';
	eval 'sub EXT2_FRAGS_PER_BLOCK {
	    local($s) = @_;
	    eval "(($s)-> &u. &ext2_sb. &s_frags_per_block)";
	}';
    }
    else {
	eval 'sub EXT2_FRAG_SIZE {
	    local($s) = @_;
	    eval "( &EXT2_MIN_FRAG_SIZE << ($s)-> &s_log_frag_size)";
	}';
	eval 'sub EXT2_FRAGS_PER_BLOCK {
	    local($s) = @_;
	    eval "( &EXT2_BLOCK_SIZE($s) /  &EXT2_FRAG_SIZE($s))";
	}';
    }
    if (defined &__KERNEL__) {
	eval 'sub EXT2_BLOCKS_PER_GROUP {
	    local($s) = @_;
	    eval "(($s)-> &u. &ext2_sb. &s_blocks_per_group)";
	}';
	eval 'sub EXT2_DESC_PER_BLOCK {
	    local($s) = @_;
	    eval "(($s)-> &u. &ext2_sb. &s_desc_per_block)";
	}';
	eval 'sub EXT2_INODES_PER_GROUP {
	    local($s) = @_;
	    eval "(($s)-> &u. &ext2_sb. &s_inodes_per_group)";
	}';
	eval 'sub EXT2_DESC_PER_BLOCK_BITS {
	    local($s) = @_;
	    eval "(($s)-> &u. &ext2_sb. &s_desc_per_block_bits)";
	}';
    }
    else {
	eval 'sub EXT2_BLOCKS_PER_GROUP {
	    local($s) = @_;
	    eval "(($s)-> &s_blocks_per_group)";
	}';
	eval 'sub EXT2_DESC_PER_BLOCK {
	    local($s) = @_;
	    eval "( &EXT2_BLOCK_SIZE($s) / $sizeof{\'struct ext2_group_desc\'})";
	}';
	eval 'sub EXT2_INODES_PER_GROUP {
	    local($s) = @_;
	    eval "(($s)-> &s_inodes_per_group)";
	}';
    }
    eval 'sub EXT2_NDIR_BLOCKS {12;}';
    eval 'sub EXT2_IND_BLOCK { &EXT2_NDIR_BLOCKS;}';
    eval 'sub EXT2_DIND_BLOCK {( &EXT2_IND_BLOCK + 1);}';
    eval 'sub EXT2_TIND_BLOCK {( &EXT2_DIND_BLOCK + 1);}';
    eval 'sub EXT2_N_BLOCKS {( &EXT2_TIND_BLOCK + 1);}';
    eval 'sub EXT2_SECRM_FL {0x00000001;}';
    eval 'sub EXT2_UNRM_FL {0x00000002;}';
    eval 'sub EXT2_COMPR_FL {0x00000004;}';
    eval 'sub EXT2_SYNC_FL {0x00000008;}';
    eval 'sub EXT2_IMMUTABLE_FL {0x00000010;}';
    eval 'sub EXT2_APPEND_FL {0x00000020;}';
    eval 'sub EXT2_NODUMP_FL {0x00000040;}';
    eval 'sub EXT2_RESERVED_FL {0x80000000;}';
    eval 'sub EXT2_IOC_GETFLAGS { &_IOR(ord(\'f\'), 1, \'long\');}';
    eval 'sub EXT2_IOC_SETFLAGS { &_IOW(ord(\'f\'), 2, \'long\');}';
    eval 'sub EXT2_IOC_GETVERSION { &_IOR(ord(\'v\'), 1, \'long\');}';
    eval 'sub EXT2_IOC_SETVERSION { &_IOW(ord(\'v\'), 2, \'long\');}';
    if (defined( &__KERNEL__) || defined( &__linux__)) {
	eval 'sub i_reserved1 { &osd1. &linux1. &l_i_reserved1;}';
	eval 'sub i_frag { &osd2. &linux2. &l_i_frag;}';
	eval 'sub i_fsize { &osd2. &linux2. &l_i_fsize;}';
	eval 'sub i_reserved2 { &osd2. &linux2. &l_i_reserved2;}';
    }
    if (defined &__hurd__) {
	eval 'sub i_translator { &osd1. &hurd1. &h_i_translator;}';
	eval 'sub i_frag { &osd2. &hurd2. &h_i_frag;;}';
	eval 'sub i_fsize { &osd2. &hurd2. &h_i_fsize;;}';
	eval 'sub i_uid_high { &osd2. &hurd2. &h_i_uid_high;}';
	eval 'sub i_gid_high { &osd2. &hurd2. &h_i_gid_high;}';
	eval 'sub i_author { &osd2. &hurd2. &h_i_author;}';
    }
    if (defined &__masix__) {
	eval 'sub i_reserved1 { &osd1. &masix1. &m_i_reserved1;}';
	eval 'sub i_frag { &osd2. &masix2. &m_i_frag;}';
	eval 'sub i_fsize { &osd2. &masix2. &m_i_fsize;}';
	eval 'sub i_reserved2 { &osd2. &masix2. &m_i_reserved2;}';
    }
    eval 'sub EXT2_VALID_FS {0x0001;}';
    eval 'sub EXT2_ERROR_FS {0x0002;}';
    eval 'sub EXT2_MOUNT_CHECK_NORMAL {0x0001;}';
    eval 'sub EXT2_MOUNT_CHECK_STRICT {0x0002;}';
    eval 'sub EXT2_MOUNT_CHECK {( &EXT2_MOUNT_CHECK_NORMAL |  &EXT2_MOUNT_CHECK_STRICT);}';
    eval 'sub EXT2_MOUNT_GRPID {0x0004;}';
    eval 'sub EXT2_MOUNT_DEBUG {0x0008;}';
    eval 'sub EXT2_MOUNT_ERRORS_CONT {0x0010;}';
    eval 'sub EXT2_MOUNT_ERRORS_RO {0x0020;}';
    eval 'sub EXT2_MOUNT_ERRORS_PANIC {0x0040;}';
    eval 'sub EXT2_MOUNT_MINIX_DF {0x0080;}';
    eval 'sub EXT2_MOUNT_NO_ATIME {0x0100;}';
    eval 'sub clear_opt {
        local($o, $opt) = @_;
        eval "$o &= ~ &EXT2_MOUNT_$opt";
    }';
    eval 'sub set_opt {
        local($o, $opt) = @_;
        eval "$o |=  &EXT2_MOUNT_$opt";
    }';
    eval 'sub test_opt {
        local($sb, $opt) = @_;
        eval "(($sb)-> &u. &ext2_sb. &s_mount_opt &  &EXT2_MOUNT_$opt)";
    }';
    eval 'sub EXT2_DFL_MAX_MNT_COUNT {20;}';
    eval 'sub EXT2_DFL_CHECKINTERVAL {0;}';
    eval 'sub EXT2_ERRORS_CONTINUE {1;}';
    eval 'sub EXT2_ERRORS_RO {2;}';
    eval 'sub EXT2_ERRORS_PANIC {3;}';
    eval 'sub EXT2_ERRORS_DEFAULT { &EXT2_ERRORS_CONTINUE;}';
    eval 'sub EXT2_OS_LINUX {0;}';
    eval 'sub EXT2_OS_HURD {1;}';
    eval 'sub EXT2_OS_MASIX {2;}';
    eval 'sub EXT2_OS_FREEBSD {3;}';
    eval 'sub EXT2_OS_LITES {4;}';
    eval 'sub EXT2_GOOD_OLD_REV {0;}';
    eval 'sub EXT2_DYNAMIC_REV {1;}';
    eval 'sub EXT2_CURRENT_REV { &EXT2_GOOD_OLD_REV;}';
    eval 'sub EXT2_MAX_SUPP_REV { &EXT2_DYNAMIC_REV;}';
    eval 'sub EXT2_GOOD_OLD_INODE_SIZE {128;}';
    eval 'sub EXT2_DEF_RESUID {0;}';
    eval 'sub EXT2_DEF_RESGID {0;}';
    eval 'sub EXT2_NAME_LEN {255;}';
    eval 'sub EXT2_DIR_PAD {4;}';
    eval 'sub EXT2_DIR_ROUND {( &EXT2_DIR_PAD - 1);}';
    eval 'sub EXT2_DIR_REC_LEN {
        local($name_len) = @_;
        eval "((($name_len) + 8 +  &EXT2_DIR_ROUND) & ~ &EXT2_DIR_ROUND)";
    }';
    eval 'sub EXT2_FEATURE_COMPAT_SUPP {0;}';
    eval 'sub EXT2_FEATURE_INCOMPAT_SUPP {0;}';
    eval 'sub EXT2_FEATURE_RO_COMPAT_SUPP {0;}';
    if (defined &__KERNEL__) {
	eval 'sub NORET_TYPE {1;}';
	eval 'sub ATTRIB_NORET { &__attribute__(( &noreturn));}';
	eval 'sub NORET_AND { &noreturn,;}';
    }
}
1;
