if (!defined &_LINUX_FS_H) {
    eval 'sub _LINUX_FS_H {1;}';
    require 'linux/config.ph';
    require 'linux/linkage.ph';
    require 'linux/limits.ph';
    require 'linux/wait.ph';
    require 'linux/types.ph';
    require 'linux/vfs.ph';
    require 'linux/net.ph';
    require 'linux/kdev_t.ph';
    require 'linux/ioctl.ph';
    eval 'sub NR_OPEN {256;}';
    eval 'sub NR_SUPER {64;}';
    eval 'sub BLOCK_SIZE {1024;}';
    eval 'sub BLOCK_SIZE_BITS {10;}';
    eval 'sub NR_INODE {3072;}';
    eval 'sub NR_FILE {1024;}';
    eval 'sub MAY_EXEC {1;}';
    eval 'sub MAY_WRITE {2;}';
    eval 'sub MAY_READ {4;}';
    eval 'sub FMODE_READ {1;}';
    eval 'sub FMODE_WRITE {2;}';
    eval 'sub READ {0;}';
    eval 'sub WRITE {1;}';
    eval 'sub READA {2;}';
    eval 'sub WRITEA {3;}';
    if (!defined &NULL) {
	eval 'sub NULL {(( &void *) 0);}';
    }
    eval 'sub NIL_FILP {(0);}';
    eval 'sub SEL_IN {1;}';
    eval 'sub SEL_OUT {2;}';
    eval 'sub SEL_EX {4;}';
    eval 'sub MS_RDONLY {1;}';
    eval 'sub MS_NOSUID {2;}';
    eval 'sub MS_NODEV {4;}';
    eval 'sub MS_NOEXEC {8;}';
    eval 'sub MS_SYNCHRONOUS {16;}';
    eval 'sub MS_REMOUNT {32;}';
    eval 'sub S_WRITE {128;}';
    eval 'sub S_APPEND {256;}';
    eval 'sub S_IMMUTABLE {512;}';
    eval 'sub MS_RMT_MASK {( &MS_RDONLY);}';
    eval 'sub MS_MGC_VAL {0xC0ED0000;}';
    eval 'sub MS_MGC_MSK {0xffff0000;}';
    eval 'sub IS_RDONLY {
        local($inode) = @_;
        eval "((($inode)-> &i_sb) && (($inode)-> &i_sb-> &s_flags &  &MS_RDONLY))";
    }';
    eval 'sub IS_NOSUID {
        local($inode) = @_;
        eval "(($inode)-> &i_flags &  &MS_NOSUID)";
    }';
    eval 'sub IS_NODEV {
        local($inode) = @_;
        eval "(($inode)-> &i_flags &  &MS_NODEV)";
    }';
    eval 'sub IS_NOEXEC {
        local($inode) = @_;
        eval "(($inode)-> &i_flags &  &MS_NOEXEC)";
    }';
    eval 'sub IS_SYNC {
        local($inode) = @_;
        eval "(($inode)-> &i_flags &  &MS_SYNCHRONOUS)";
    }';
    eval 'sub IS_WRITABLE {
        local($inode) = @_;
        eval "(($inode)-> &i_flags &  &S_WRITE)";
    }';
    eval 'sub IS_APPEND {
        local($inode) = @_;
        eval "(($inode)-> &i_flags &  &S_APPEND)";
    }';
    eval 'sub IS_IMMUTABLE {
        local($inode) = @_;
        eval "(($inode)-> &i_flags &  &S_IMMUTABLE)";
    }';
    eval 'sub BLKROSET { &_IO(0x12,93);}';
    eval 'sub BLKROGET { &_IO(0x12,94);}';
    eval 'sub BLKRRPART { &_IO(0x12,95);}';
    eval 'sub BLKGETSIZE { &_IO(0x12,96);}';
    eval 'sub BLKFLSBUF { &_IO(0x12,97);}';
    eval 'sub BLKRASET { &_IO(0x12,98);}';
    eval 'sub BLKRAGET { &_IO(0x12,99);}';
    eval 'sub BMAP_IOCTL {1;}';
    eval 'sub FIBMAP { &_IO(0x00,1);}';
    eval 'sub FIGETBSZ { &_IO(0x00,2);}';
    if (defined &__KERNEL__) {
	require 'asm/semaphore.ph';
	require 'asm/byteorder.ph';
	require 'asm/bitops.ph';
	eval 'sub BH_Uptodate {0;}';
	eval 'sub BH_Dirty {1;}';
	eval 'sub BH_Lock {2;}';
	eval 'sub BH_Req {3;}';
	eval 'sub BH_Touched {4;}';
	eval 'sub BH_Has_aged {5;}';
	eval 'sub BH_Protected {6;}';
	eval 'sub BH_FreeOnIO {7;}';
	require 'linux/pipe_fs_i.ph';
	require 'linux/minix_fs_i.ph';
	require 'linux/ext_fs_i.ph';
	require 'linux/ext2_fs_i.ph';
	require 'linux/hpfs_fs_i.ph';
	require 'linux/msdos_fs_i.ph';
	require 'linux/umsdos_fs_i.ph';
	require 'linux/iso_fs_i.ph';
	require 'linux/nfs_fs_i.ph';
	require 'linux/xia_fs_i.ph';
	require 'linux/sysv_fs_i.ph';
	require 'linux/affs_fs_i.ph';
	require 'linux/ufs_fs_i.ph';
	eval 'sub ATTR_MODE {1;}';
	eval 'sub ATTR_UID {2;}';
	eval 'sub ATTR_GID {4;}';
	eval 'sub ATTR_SIZE {8;}';
	eval 'sub ATTR_ATIME {16;}';
	eval 'sub ATTR_MTIME {32;}';
	eval 'sub ATTR_CTIME {64;}';
	eval 'sub ATTR_ATIME_SET {128;}';
	eval 'sub ATTR_MTIME_SET {256;}';
	eval 'sub ATTR_FORCE {512;}';
	require 'linux/quota.ph';
	require 'linux/fcntl.ph';
	require 'linux/stat.ph';
	eval 'sub FLOCK_VERIFY_READ {1;}';
	eval 'sub FLOCK_VERIFY_WRITE {2;}';
	if (defined &CONFIG_LOCK_MANDATORY) {
	}
	if (defined &CONFIG_LOCK_MANDATORY) {
	}
	eval 'sub FASYNC_MAGIC {0x4601;}';
	require 'linux/minix_fs_sb.ph';
	require 'linux/ext_fs_sb.ph';
	require 'linux/ext2_fs_sb.ph';
	require 'linux/hpfs_fs_sb.ph';
	require 'linux/msdos_fs_sb.ph';
	require 'linux/iso_fs_sb.ph';
	require 'linux/nfs_fs_sb.ph';
	require 'linux/xia_fs_sb.ph';
	require 'linux/sysv_fs_sb.ph';
	require 'linux/affs_fs_sb.ph';
	require 'linux/ufs_fs_sb.ph';
	eval 'sub BUF_CLEAN {0;}';
	eval 'sub BUF_LOCKED {1;}';
	eval 'sub BUF_LOCKED1 {2;}';
	eval 'sub BUF_DIRTY {3;}';
	eval 'sub NR_LIST {4;}';
	if (defined &CONFIG_BLK_DEV_INITRD) {
	}
	require 'linux/minix_fs.ph';
	require 'linux/minix_fs_sb.ph';
	if (defined &__LITTLE_ENDIAN) {
	    eval 'sub swab32 {
	        local($x) = @_;
	        eval "($x)";
	    }';
	    eval 'sub swab16 {
	        local($x) = @_;
	        eval "($x)";
	    }';
	}
	else {
	}
    }
}
1;
