if (!defined &_LINUX_MM_H) {
    eval 'sub _LINUX_MM_H {1;}';
    require 'linux/sched.ph';
    require 'linux/errno.ph';
    require 'linux/kernel.ph';
    if (defined &__KERNEL__) {
	require 'linux/string.ph';
	require 'asm/page.ph';
	require 'asm/atomic.ph';
	eval 'sub VERIFY_READ {0;}';
	eval 'sub VERIFY_WRITE {1;}';
	eval 'sub VM_READ {0x0001;}';
	eval 'sub VM_WRITE {0x0002;}';
	eval 'sub VM_EXEC {0x0004;}';
	eval 'sub VM_SHARED {0x0008;}';
	eval 'sub VM_MAYREAD {0x0010;}';
	eval 'sub VM_MAYWRITE {0x0020;}';
	eval 'sub VM_MAYEXEC {0x0040;}';
	eval 'sub VM_MAYSHARE {0x0080;}';
	eval 'sub VM_GROWSDOWN {0x0100;}';
	eval 'sub VM_GROWSUP {0x0200;}';
	eval 'sub VM_SHM {0x0400;}';
	eval 'sub VM_DENYWRITE {0x0800;}';
	eval 'sub VM_EXECUTABLE {0x1000;}';
	eval 'sub VM_LOCKED {0x2000;}';
	eval 'sub VM_IO {0x4000;}';
	eval 'sub VM_STACK_FLAGS {0x0177;}';
	eval 'sub PG_locked {0;}';
	eval 'sub PG_error {1;}';
	eval 'sub PG_referenced {2;}';
	eval 'sub PG_uptodate {3;}';
	eval 'sub PG_free_after {4;}';
	eval 'sub PG_decr_after {5;}';
	eval 'sub PG_swap_unlock_after {6;}';
	eval 'sub PG_DMA {7;}';
	eval 'sub PG_reserved {31;}';
	eval 'sub PageLocked {
	    local($page) = @_;
	    eval "( &test_bit( &PG_locked, &($page)-> &flags))";
	}';
	eval 'sub PageError {
	    local($page) = @_;
	    eval "( &test_bit( &PG_error, &($page)-> &flags))";
	}';
	eval 'sub PageReferenced {
	    local($page) = @_;
	    eval "( &test_bit( &PG_referenced, &($page)-> &flags))";
	}';
	eval 'sub PageDirty {
	    local($page) = @_;
	    eval "( &test_bit( &PG_dirty, &($page)-> &flags))";
	}';
	eval 'sub PageUptodate {
	    local($page) = @_;
	    eval "( &test_bit( &PG_uptodate, &($page)-> &flags))";
	}';
	eval 'sub PageFreeAfter {
	    local($page) = @_;
	    eval "( &test_bit( &PG_free_after, &($page)-> &flags))";
	}';
	eval 'sub PageDecrAfter {
	    local($page) = @_;
	    eval "( &test_bit( &PG_decr_after, &($page)-> &flags))";
	}';
	eval 'sub PageSwapUnlockAfter {
	    local($page) = @_;
	    eval "( &test_bit( &PG_swap_unlock_after, &($page)-> &flags))";
	}';
	eval 'sub PageDMA {
	    local($page) = @_;
	    eval "( &test_bit( &PG_DMA, &($page)-> &flags))";
	}';
	eval 'sub PageReserved {
	    local($page) = @_;
	    eval "( &test_bit( &PG_reserved, &($page)-> &flags))";
	}';
	eval 'sub __get_free_page {
	    local($priority) = @_;
	    eval " &__get_free_pages(($priority),0,0)";
	}';
	eval 'sub __get_dma_pages {
	    local($priority, $order) = @_;
	    eval " &__get_free_pages(($priority),($order),1)";
	}';
	eval 'sub free_page {
	    local($addr) = @_;
	    eval " &free_pages(($addr),0)";
	}';
	eval 'sub GFP_BUFFER {0x00;}';
	eval 'sub GFP_ATOMIC {0x01;}';
	eval 'sub GFP_USER {0x02;}';
	eval 'sub GFP_KERNEL {0x03;}';
	eval 'sub GFP_NOBUFFER {0x04;}';
	eval 'sub GFP_NFS {0x05;}';
	eval 'sub GFP_DMA {0x80;}';
	eval 'sub GFP_LEVEL_MASK {0xf;}';
	eval 'sub avl_empty {  &NULL;}';
    }
}
1;
