if (!defined &_LINUX_NCP_FS_H) {
    eval 'sub _LINUX_NCP_FS_H {1;}';
    require 'linux/fs.ph';
    require 'linux/in.ph';
    require 'linux/types.ph';
    require 'linux/ncp_mount.ph';
    require 'linux/ncp_fs_sb.ph';
    require 'linux/ncp_fs_i.ph';
    eval 'sub NCP_IOC_NCPREQUEST { &_IOR(ord(\'n\'), 1, \'struct ncp_ioctl_request\');}';
    eval 'sub NCP_IOC_GETMOUNTUID { &_IOW(ord(\'n\'), 2,  &uid_t);}';
    eval 'sub NCP_IOC_CONN_LOGGED_IN { &_IO(ord(\'n\'), 3);}';
    eval 'sub NCP_GET_FS_INFO_VERSION {(1);}';
    eval 'sub NCP_IOC_GET_FS_INFO { &_IOWR(ord(\'n\'), 4, \'struct ncp_fs_info\');}';
    eval 'sub NCP_PACKET_SIZE {4070;}';
    eval 'sub NCP_MAXPATHLEN {255;}';
    eval 'sub NCP_MAXNAMELEN {14;}';
    eval 'sub NCP_MSG_COMMAND {"/sbin/nwmsg";}';
    if (defined &__KERNEL__) {
	eval 'sub NCP_READDIR_CACHE_SIZE {64;}';
	eval 'sub NCP_MAX_RPC_TIMEOUT {(6* &HZ);}';
	eval 'sub NCP_SUPER_MAGIC {0x564c;}';
	eval 'sub NCP_SBP {
	    local($sb) = @_;
	    eval "((($sb)-> &u. &generic_sbp))";
	}';
	eval 'sub NCP_INOP {
	    local($inode) = @_;
	    eval "((($inode)-> &u. &generic_ip))";
	}';
	eval 'sub NCP_SERVER {
	    local($inode) = @_;
	    eval " &NCP_SBP(($inode)-> &i_sb)";
	}';
	eval 'sub NCP_FINFO {
	    local($inode) = @_;
	    eval "(&( &NCP_INOP($inode)-> &finfo))";
	}';
	eval 'sub NCP_ISTRUCT {
	    local($inode) = @_;
	    eval "(&( &NCP_FINFO($inode)-> &i))";
	}';
	if (defined &DEBUG_NCP_MALLOC) {
	    require 'linux/malloc.ph';
	}
	else {
	    eval 'sub ncp_kmalloc {
	        local($s,$p) = @_;
	        eval " &kmalloc($s,$p)";
	    }';
	    eval 'sub ncp_kfree_s {
	        local($o,$s) = @_;
	        eval " &kfree_s($o,$s)";
	    }';
	}
	if ((defined(&DEBUG_NCP) ? &DEBUG_NCP : 0) > 0) {
	    eval 'sub DPRINTK {( &format,  &args...)  &printk( &format ,   &args);}';
	}
	else {
	    eval 'sub DPRINTK {( &format,  &args...);}';
	}
	if ((defined(&DEBUG_NCP) ? &DEBUG_NCP : 0) > 1) {
	    eval 'sub DDPRINTK {( &format,  &args...)  &printk( &format ,   &args);}';
	}
	else {
	    eval 'sub DDPRINTK {( &format,  &args...);}';
	}
    }
}
1;
