if (!defined &_LINUX_NFS_FS_H) {
    eval 'sub _LINUX_NFS_FS_H {1;}';
    require 'linux/nfs.ph';
    require 'linux/in.ph';
    require 'linux/nfs_mount.ph';
    eval 'sub NFS_READDIR_CACHE_SIZE {64;}';
    eval 'sub NFS_MAX_FILE_IO_BUFFER_SIZE {16384;}';
    eval 'sub NFS_DEF_FILE_IO_BUFFER_SIZE {1024;}';
    eval 'sub NFS_MAX_RPC_TIMEOUT {(6* &HZ);}';
    eval 'sub NFS_LOOKUP_CACHE_SIZE {64;}';
    eval 'sub NFS_SUPER_MAGIC {0x6969;}';
    eval 'sub NFS_SERVER {
        local($inode) = @_;
        eval "(&($inode)-> &i_sb-> &u. &nfs_sb. &s_server)";
    }';
    eval 'sub NFS_FH {
        local($inode) = @_;
        eval "(&($inode)-> &u. &nfs_i. &fhandle)";
    }';
    eval 'sub NFS_RENAMED_DIR {
        local($inode) = @_;
        eval "(($inode)-> &u. &nfs_i. &silly_rename_dir)";
    }';
    eval 'sub NFS_READTIME {
        local($inode) = @_;
        eval "(($inode)-> &u. &nfs_i. &read_cache_jiffies)";
    }';
    eval 'sub NFS_OLDMTIME {
        local($inode) = @_;
        eval "(($inode)-> &u. &nfs_i. &read_cache_mtime)";
    }';
    eval 'sub NFS_ATTRTIMEO {
        local($inode) = @_;
        eval "(($inode)-> &u. &nfs_i. &attrtimeo)";
    }';
    eval 'sub NFS_MINATTRTIMEO {
        local($inode) = @_;
        eval "( &S_ISREG(($inode)-> &i_mode)?  &NFS_SERVER($inode)-> &acregmin :  &NFS_SERVER($inode)-> &acdirmin)";
    }';
    eval 'sub NFS_CACHEINV {
        local($inode) = @_;
        eval " &do {  &NFS_READTIME($inode) =  &jiffies - 1000000;  &NFS_OLDMTIME($inode) = 0; }  &while (0)";
    }';
    if (defined &__KERNEL__) {
	eval 'sub NFS_ROOT {"/tftpboot/%s";}';
	eval 'sub NFS_ROOT_NAME_LEN {256;}';
	eval 'sub NFS_ROOT_ADDRS_LEN {128;}';
    }
}
1;
