if (!defined &_LINUX_SCHED_H) {
    eval 'sub _LINUX_SCHED_H {1;}';
    require 'asm/param.ph';
    require 'linux/binfmts.ph';
    require 'linux/personality.ph';
    require 'linux/tasks.ph';
    require 'linux/kernel.ph';
    require 'asm/system.ph';
    require 'asm/semaphore.ph';
    require 'asm/page.ph';
    require 'linux/smp.ph';
    require 'linux/tty.ph';
    require 'linux/sem.ph';
    eval 'sub CSIGNAL {0x000000ff;}';
    eval 'sub CLONE_VM {0x00000100;}';
    eval 'sub CLONE_FS {0x00000200;}';
    eval 'sub CLONE_FILES {0x00000400;}';
    eval 'sub CLONE_SIGHAND {0x00000800;}';
    eval 'sub CLONE_PID {0x00001000;}';
    eval 'sub FSHIFT {11;}';
    eval 'sub FIXED_1 {(1<< &FSHIFT);}';
    eval 'sub LOAD_FREQ {(5* &HZ);}';
    eval 'sub EXP_1 {1884;}';
    eval 'sub EXP_5 {2014;}';
    eval 'sub EXP_15 {2037;}';
    eval 'sub CALC_LOAD {
        local($load,$exp,$n) = @_;
        eval "$load *= $exp; $load += $n*( &FIXED_1-$exp); $load >>=  &FSHIFT;";
    }';
    eval 'sub CT_TO_SECS {
        local($x) = @_;
        eval "(($x) /  &HZ)";
    }';
    eval 'sub CT_TO_USECS {
        local($x) = @_;
        eval "((($x) %  &HZ) * 1000000/ &HZ)";
    }';
    eval 'sub FIRST_TASK { $task[0];}';
    eval 'sub LAST_TASK { $task[ &NR_TASKS-1];}';
    require 'linux/head.ph';
    require 'linux/fs.ph';
    require 'linux/signal.ph';
    require 'linux/time.ph';
    require 'linux/param.ph';
    require 'linux/resource.ph';
    require 'linux/ptrace.ph';
    require 'linux/timer.ph';
    require 'asm/processor.ph';
    eval 'sub TASK_RUNNING {0;}';
    eval 'sub TASK_INTERRUPTIBLE {1;}';
    eval 'sub TASK_UNINTERRUPTIBLE {2;}';
    eval 'sub TASK_ZOMBIE {3;}';
    eval 'sub TASK_STOPPED {4;}';
    eval 'sub TASK_SWAPPING {5;}';
    eval 'sub SCHED_OTHER {0;}';
    eval 'sub SCHED_FIFO {1;}';
    eval 'sub SCHED_RR {2;}';
    if (!defined &NULL) {
	eval 'sub NULL {(( &void *) 0);}';
    }
    if (defined &__KERNEL__) {
	eval 'sub INIT_FILES {{ 1, { { 0, } }, { { 0, } }, {  &NULL, } };}';
	eval 'sub INIT_FS {{ 1, 0022,  &NULL,  &NULL };}';
	eval 'sub INIT_MM {{ 1,  &swapper_pg_dir, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, & &init_mmap, & &init_mmap,  &MUTEX };}';
	eval 'sub INIT_SIGNALS {{ 1, { {0,}, } };}';
	if (defined &__SMP__) {
	}
	eval 'sub PF_ALIGNWARN {0x00000001;}';
	eval 'sub PF_PTRACED {0x00000010;}';
	eval 'sub PF_TRACESYS {0x00000020;}';
	eval 'sub PF_FORKNOEXEC {0x00000040;}';
	eval 'sub PF_SUPERPRIV {0x00000100;}';
	eval 'sub PF_DUMPCORE {0x00000200;}';
	eval 'sub PF_SIGNALED {0x00000400;}';
	eval 'sub PF_STARTING {0x00000002;}';
	eval 'sub PF_EXITING {0x00000004;}';
	eval 'sub PF_USEDFPU {0x00100000;}';
	eval 'sub PF_DTRACE {0x00200000;}';
	eval 'sub _STK_LIM {(8*1024*1024);}';
	eval 'sub DEF_PRIORITY {(20* &HZ/100);}';
	eval 'sub INIT_TASK {{ 0, &DEF_PRIORITY, &DEF_PRIORITY,0,0,0,0, { 0, }, & &default_exec_domain,  &NULL, & &init_task,& &init_task, & &init_task, & &init_task, 0, & &init_kernel_stack, 0,0,0,0,0, 0,0,0,0,0, { &NOGROUP,}, & &init_task,& &init_task, &NULL, &NULL, &NULL, &NULL, 0,0,0,0,0,0,0,0, 0, &SCHED_OTHER,0,0,0,0,0,0,0, {  &NULL,  &NULL, 0, 0,  &it_real_fn }, 0,0,0,0,0, 0,0,0,0,0,0, 0,0,0,0,0,  &INIT_RLIMITS, 0, "swapper", 0, &NULL,  &NULL,  &NULL,  &NULL,  &INIT_TSS, & &init_fs, & &init_files, & &init_mm, & &init_signals, };}';
	if (!defined &__sparc__) {
	    eval 'sub current {(0+ $current_set[ &smp_processor_id()]);}';
	}
	else {
	}
	eval 'sub CURRENT_TIME {( &xtime. &tv_sec);}';
	if (!defined &__sparc__) {
	}
	eval 'sub REMOVE_LINKS {
	    local($p) = @_;
	    eval " &do { \'unsigned long\'  &flags;  &save_flags( &flags) ;  &cli(); ($p)-> &next_task-> &prev_task = ($p)-> &prev_task; ($p)-> &prev_task-> &next_task = ($p)-> &next_task;  &restore_flags( &flags);  &if (($p)-> &p_osptr) ($p)-> &p_osptr-> &p_ysptr = ($p)-> &p_ysptr;  &if (($p)-> &p_ysptr) ($p)-> &p_ysptr-> &p_osptr = ($p)-> &p_osptr;  &else ($p)-> &p_pptr-> &p_cptr = ($p)-> &p_osptr; }  &while (0)";
	}';
	eval 'sub SET_LINKS {
	    local($p) = @_;
	    eval " &do { \'unsigned long\'  &flags;  &save_flags( &flags);  &cli(); ($p)-> &next_task = & &init_task; ($p)-> &prev_task =  &init_task. &prev_task;  &init_task. &prev_task-> &next_task = ($p);  &init_task. &prev_task = ($p);  &restore_flags( &flags); ($p)-> &p_ysptr =  &NULL;  &if ((($p)-> &p_osptr = ($p)-> &p_pptr-> &p_cptr) !=  &NULL) ($p)-> &p_osptr-> &p_ysptr = $p; ($p)-> &p_pptr-> &p_cptr = $p; }  &while (0)";
	}';
	eval 'sub for_each_task {
	    local($p) = @_;
	    eval " &for ($p = & &init_task ; ($p = $p-> &next_task) != & &init_task ; )";
	}';
    }
}
1;
