if (!defined &_LINUX_SMB_FS_H) {
    eval 'sub _LINUX_SMB_FS_H {1;}';
    require 'linux/smb.ph';
    require 'linux/fs.ph';
    require 'linux/in.ph';
    require 'linux/types.ph';
    require 'linux/smb_mount.ph';
    require 'linux/smb_fs_sb.ph';
    require 'linux/smb_fs_i.ph';
    eval 'sub SMB_IOC_GETMOUNTUID { &_IOR(ord(\'u\'), 1,  &uid_t);}';
    if (defined &__KERNEL__) {
	eval 'sub SMB_READDIR_CACHE_SIZE {64;}';
	eval 'sub SMB_CACHE_TABLE_SIZE {64;}';
	eval 'sub SMB_SUPER_MAGIC {0x517B;}';
	eval 'sub SMB_SBP {
	    local($sb) = @_;
	    eval "(($sb-> &u. &generic_sbp))";
	}';
	eval 'sub SMB_INOP {
	    local($inode) = @_;
	    eval "(($inode-> &u. &generic_ip))";
	}';
	eval 'sub SMB_SERVER {
	    local($inode) = @_;
	    eval "(&( &SMB_SBP($inode-> &i_sb)-> &s_server))";
	}';
	eval 'sub SMB_SERVATTR {
	    local($inode) = @_;
	    eval "(&( &SMB_SBP($inode-> &i_sb)-> &s_attr))";
	}';
	eval 'sub SMB_FINFO {
	    local($inode) = @_;
	    eval "(&( &SMB_INOP($inode)-> &finfo))";
	}';
	eval 'sub SMB_HEADER_LEN {37;}';
	if (defined &DEBUG_SMB_MALLOC) {
	    require 'linux/malloc.ph';
	}
	else {
	    eval 'sub smb_kmalloc {
	        local($s,$p) = @_;
	        eval " &kmalloc($s,$p)";
	    }';
	    eval 'sub smb_kfree_s {
	        local($o,$s) = @_;
	        eval " &kfree_s($o,$s)";
	    }';
	    eval 'sub smb_vmalloc {
	        local($s) = @_;
	        eval " &vmalloc($s)";
	    }';
	    eval 'sub smb_vfree {
	        local($o) = @_;
	        eval " &vfree($o)";
	    }';
	}
	if ((defined(&DEBUG_SMB) ? &DEBUG_SMB : 0) > 0) {
	    eval 'sub DPRINTK {( &format,  &args...)  &printk( &format ,   &args);}';
	}
	else {
	    eval 'sub DPRINTK {( &format,  &args...);}';
	}
	if ((defined(&DEBUG_SMB) ? &DEBUG_SMB : 0) > 1) {
	    eval 'sub DDPRINTK {( &format,  &args...)  &printk( &format ,   &args);}';
	}
	else {
	    eval 'sub DDPRINTK {( &format,  &args...);}';
	}
	if (0) {
	}
	else {
	}
    }
}
1;
