if (!defined &_LINUX_TTY_H) {
    eval 'sub _LINUX_TTY_H {1;}';
    eval 'sub MIN_NR_CONSOLES {1;}';
    eval 'sub MAX_NR_CONSOLES {63;}';
    eval 'sub MAX_NR_USER_CONSOLES {63;}';
    if (defined &__KERNEL__) {
	require 'linux/fs.ph';
	require 'linux/termios.ph';
	require 'linux/tqueue.ph';
	require 'linux/tty_driver.ph';
	require 'linux/tty_ldisc.ph';
	require 'asm/system.ph';
	eval 'sub NR_PTYS {256;}';
	eval 'sub NR_LDISCS {16;}';
	eval 'sub ORIG_X {( &screen_info. &orig_x);}';
	eval 'sub ORIG_Y {( &screen_info. &orig_y);}';
	eval 'sub ORIG_VIDEO_MODE {( &screen_info. &orig_video_mode);}';
	eval 'sub ORIG_VIDEO_COLS {( &screen_info. &orig_video_cols);}';
	eval 'sub ORIG_VIDEO_EGA_BX {( &screen_info. &orig_video_ega_bx);}';
	eval 'sub ORIG_VIDEO_LINES {( &screen_info. &orig_video_lines);}';
	eval 'sub ORIG_VIDEO_ISVGA {( &screen_info. &orig_video_isVGA);}';
	eval 'sub ORIG_VIDEO_POINTS {( &screen_info. &orig_video_points);}';
	eval 'sub VIDEO_TYPE_MDA {0x10;}';
	eval 'sub VIDEO_TYPE_CGA {0x11;}';
	eval 'sub VIDEO_TYPE_EGAM {0x20;}';
	eval 'sub VIDEO_TYPE_EGAC {0x21;}';
	eval 'sub VIDEO_TYPE_VGAC {0x22;}';
	eval 'sub VIDEO_TYPE_TGAC {0x40;}';
	eval 'sub VIDEO_TYPE_SUN {0x50;}';
	eval 'sub __DISABLED_CHAR {ord(\'\\0\');}';
	eval 'sub TTY_FLIPBUF_SIZE {512;}';
	eval 'sub TTY_NORMAL {0;}';
	eval 'sub TTY_BREAK {1;}';
	eval 'sub TTY_FRAME {2;}';
	eval 'sub TTY_PARITY {3;}';
	eval 'sub TTY_OVERRUN {4;}';
	eval 'sub INTR_CHAR {
	    local($tty) = @_;
	    eval "(($tty)-> &termios-> $c_cc[ &VINTR])";
	}';
	eval 'sub QUIT_CHAR {
	    local($tty) = @_;
	    eval "(($tty)-> &termios-> $c_cc[ &VQUIT])";
	}';
	eval 'sub ERASE_CHAR {
	    local($tty) = @_;
	    eval "(($tty)-> &termios-> $c_cc[ &VERASE])";
	}';
	eval 'sub KILL_CHAR {
	    local($tty) = @_;
	    eval "(($tty)-> &termios-> $c_cc[ &VKILL])";
	}';
	eval 'sub EOF_CHAR {
	    local($tty) = @_;
	    eval "(($tty)-> &termios-> $c_cc[ &VEOF])";
	}';
	eval 'sub TIME_CHAR {
	    local($tty) = @_;
	    eval "(($tty)-> &termios-> $c_cc[ &VTIME])";
	}';
	eval 'sub MIN_CHAR {
	    local($tty) = @_;
	    eval "(($tty)-> &termios-> $c_cc[ &VMIN])";
	}';
	eval 'sub SWTC_CHAR {
	    local($tty) = @_;
	    eval "(($tty)-> &termios-> $c_cc[ &VSWTC])";
	}';
	eval 'sub START_CHAR {
	    local($tty) = @_;
	    eval "(($tty)-> &termios-> $c_cc[ &VSTART])";
	}';
	eval 'sub STOP_CHAR {
	    local($tty) = @_;
	    eval "(($tty)-> &termios-> $c_cc[ &VSTOP])";
	}';
	eval 'sub SUSP_CHAR {
	    local($tty) = @_;
	    eval "(($tty)-> &termios-> $c_cc[ &VSUSP])";
	}';
	eval 'sub EOL_CHAR {
	    local($tty) = @_;
	    eval "(($tty)-> &termios-> $c_cc[ &VEOL])";
	}';
	eval 'sub REPRINT_CHAR {
	    local($tty) = @_;
	    eval "(($tty)-> &termios-> $c_cc[ &VREPRINT])";
	}';
	eval 'sub DISCARD_CHAR {
	    local($tty) = @_;
	    eval "(($tty)-> &termios-> $c_cc[ &VDISCARD])";
	}';
	eval 'sub WERASE_CHAR {
	    local($tty) = @_;
	    eval "(($tty)-> &termios-> $c_cc[ &VWERASE])";
	}';
	eval 'sub LNEXT_CHAR {
	    local($tty) = @_;
	    eval "(($tty)-> &termios-> $c_cc[ &VLNEXT])";
	}';
	eval 'sub EOL2_CHAR {
	    local($tty) = @_;
	    eval "(($tty)-> &termios-> $c_cc[ &VEOL2])";
	}';
	eval 'sub _I_FLAG {
	    local($tty,$f) = @_;
	    eval "(($tty)-> &termios-> &c_iflag & ($f))";
	}';
	eval 'sub _O_FLAG {
	    local($tty,$f) = @_;
	    eval "(($tty)-> &termios-> &c_oflag & ($f))";
	}';
	eval 'sub _C_FLAG {
	    local($tty,$f) = @_;
	    eval "(($tty)-> &termios-> &c_cflag & ($f))";
	}';
	eval 'sub _L_FLAG {
	    local($tty,$f) = @_;
	    eval "(($tty)-> &termios-> &c_lflag & ($f))";
	}';
	eval 'sub I_IGNBRK {
	    local($tty) = @_;
	    eval " &_I_FLAG(($tty), &IGNBRK)";
	}';
	eval 'sub I_BRKINT {
	    local($tty) = @_;
	    eval " &_I_FLAG(($tty), &BRKINT)";
	}';
	eval 'sub I_IGNPAR {
	    local($tty) = @_;
	    eval " &_I_FLAG(($tty), &IGNPAR)";
	}';
	eval 'sub I_PARMRK {
	    local($tty) = @_;
	    eval " &_I_FLAG(($tty), &PARMRK)";
	}';
	eval 'sub I_INPCK {
	    local($tty) = @_;
	    eval " &_I_FLAG(($tty), &INPCK)";
	}';
	eval 'sub I_ISTRIP {
	    local($tty) = @_;
	    eval " &_I_FLAG(($tty), &ISTRIP)";
	}';
	eval 'sub I_INLCR {
	    local($tty) = @_;
	    eval " &_I_FLAG(($tty), &INLCR)";
	}';
	eval 'sub I_IGNCR {
	    local($tty) = @_;
	    eval " &_I_FLAG(($tty), &IGNCR)";
	}';
	eval 'sub I_ICRNL {
	    local($tty) = @_;
	    eval " &_I_FLAG(($tty), &ICRNL)";
	}';
	eval 'sub I_IUCLC {
	    local($tty) = @_;
	    eval " &_I_FLAG(($tty), &IUCLC)";
	}';
	eval 'sub I_IXON {
	    local($tty) = @_;
	    eval " &_I_FLAG(($tty), &IXON)";
	}';
	eval 'sub I_IXANY {
	    local($tty) = @_;
	    eval " &_I_FLAG(($tty), &IXANY)";
	}';
	eval 'sub I_IXOFF {
	    local($tty) = @_;
	    eval " &_I_FLAG(($tty), &IXOFF)";
	}';
	eval 'sub I_IMAXBEL {
	    local($tty) = @_;
	    eval " &_I_FLAG(($tty), &IMAXBEL)";
	}';
	eval 'sub O_OPOST {
	    local($tty) = @_;
	    eval " &_O_FLAG(($tty), &OPOST)";
	}';
	eval 'sub O_OLCUC {
	    local($tty) = @_;
	    eval " &_O_FLAG(($tty), &OLCUC)";
	}';
	eval 'sub O_ONLCR {
	    local($tty) = @_;
	    eval " &_O_FLAG(($tty), &ONLCR)";
	}';
	eval 'sub O_OCRNL {
	    local($tty) = @_;
	    eval " &_O_FLAG(($tty), &OCRNL)";
	}';
	eval 'sub O_ONOCR {
	    local($tty) = @_;
	    eval " &_O_FLAG(($tty), &ONOCR)";
	}';
	eval 'sub O_ONLRET {
	    local($tty) = @_;
	    eval " &_O_FLAG(($tty), &ONLRET)";
	}';
	eval 'sub O_OFILL {
	    local($tty) = @_;
	    eval " &_O_FLAG(($tty), &OFILL)";
	}';
	eval 'sub O_OFDEL {
	    local($tty) = @_;
	    eval " &_O_FLAG(($tty), &OFDEL)";
	}';
	eval 'sub O_NLDLY {
	    local($tty) = @_;
	    eval " &_O_FLAG(($tty), &NLDLY)";
	}';
	eval 'sub O_CRDLY {
	    local($tty) = @_;
	    eval " &_O_FLAG(($tty), &CRDLY)";
	}';
	eval 'sub O_TABDLY {
	    local($tty) = @_;
	    eval " &_O_FLAG(($tty), &TABDLY)";
	}';
	eval 'sub O_BSDLY {
	    local($tty) = @_;
	    eval " &_O_FLAG(($tty), &BSDLY)";
	}';
	eval 'sub O_VTDLY {
	    local($tty) = @_;
	    eval " &_O_FLAG(($tty), &VTDLY)";
	}';
	eval 'sub O_FFDLY {
	    local($tty) = @_;
	    eval " &_O_FLAG(($tty), &FFDLY)";
	}';
	eval 'sub C_BAUD {
	    local($tty) = @_;
	    eval " &_C_FLAG(($tty), &CBAUD)";
	}';
	eval 'sub C_CSIZE {
	    local($tty) = @_;
	    eval " &_C_FLAG(($tty), &CSIZE)";
	}';
	eval 'sub C_CSTOPB {
	    local($tty) = @_;
	    eval " &_C_FLAG(($tty), &CSTOPB)";
	}';
	eval 'sub C_CREAD {
	    local($tty) = @_;
	    eval " &_C_FLAG(($tty), &CREAD)";
	}';
	eval 'sub C_PARENB {
	    local($tty) = @_;
	    eval " &_C_FLAG(($tty), &PARENB)";
	}';
	eval 'sub C_PARODD {
	    local($tty) = @_;
	    eval " &_C_FLAG(($tty), &PARODD)";
	}';
	eval 'sub C_HUPCL {
	    local($tty) = @_;
	    eval " &_C_FLAG(($tty), &HUPCL)";
	}';
	eval 'sub C_CLOCAL {
	    local($tty) = @_;
	    eval " &_C_FLAG(($tty), &CLOCAL)";
	}';
	eval 'sub C_CIBAUD {
	    local($tty) = @_;
	    eval " &_C_FLAG(($tty), &CIBAUD)";
	}';
	eval 'sub C_CRTSCTS {
	    local($tty) = @_;
	    eval " &_C_FLAG(($tty), &CRTSCTS)";
	}';
	eval 'sub L_ISIG {
	    local($tty) = @_;
	    eval " &_L_FLAG(($tty), &ISIG)";
	}';
	eval 'sub L_ICANON {
	    local($tty) = @_;
	    eval " &_L_FLAG(($tty), &ICANON)";
	}';
	eval 'sub L_XCASE {
	    local($tty) = @_;
	    eval " &_L_FLAG(($tty), &XCASE)";
	}';
	eval 'sub L_ECHO {
	    local($tty) = @_;
	    eval " &_L_FLAG(($tty), &ECHO)";
	}';
	eval 'sub L_ECHOE {
	    local($tty) = @_;
	    eval " &_L_FLAG(($tty), &ECHOE)";
	}';
	eval 'sub L_ECHOK {
	    local($tty) = @_;
	    eval " &_L_FLAG(($tty), &ECHOK)";
	}';
	eval 'sub L_ECHONL {
	    local($tty) = @_;
	    eval " &_L_FLAG(($tty), &ECHONL)";
	}';
	eval 'sub L_NOFLSH {
	    local($tty) = @_;
	    eval " &_L_FLAG(($tty), &NOFLSH)";
	}';
	eval 'sub L_TOSTOP {
	    local($tty) = @_;
	    eval " &_L_FLAG(($tty), &TOSTOP)";
	}';
	eval 'sub L_ECHOCTL {
	    local($tty) = @_;
	    eval " &_L_FLAG(($tty), &ECHOCTL)";
	}';
	eval 'sub L_ECHOPRT {
	    local($tty) = @_;
	    eval " &_L_FLAG(($tty), &ECHOPRT)";
	}';
	eval 'sub L_ECHOKE {
	    local($tty) = @_;
	    eval " &_L_FLAG(($tty), &ECHOKE)";
	}';
	eval 'sub L_FLUSHO {
	    local($tty) = @_;
	    eval " &_L_FLAG(($tty), &FLUSHO)";
	}';
	eval 'sub L_PENDIN {
	    local($tty) = @_;
	    eval " &_L_FLAG(($tty), &PENDIN)";
	}';
	eval 'sub L_IEXTEN {
	    local($tty) = @_;
	    eval " &_L_FLAG(($tty), &IEXTEN)";
	}';
	eval 'sub N_TTY_BUF_SIZE {4096;}';
	eval 'sub TTY_MAGIC {0x5401;}';
	eval 'sub TTY_THROTTLED {0;}';
	eval 'sub TTY_IO_ERROR {1;}';
	eval 'sub TTY_OTHER_CLOSED {2;}';
	eval 'sub TTY_EXCLUSIVE {3;}';
	eval 'sub TTY_DEBUG {4;}';
	eval 'sub TTY_DO_WRITE_WAKEUP {5;}';
	eval 'sub TTY_PUSH {6;}';
	eval 'sub TTY_CLOSING {7;}';
	eval 'sub TTY_WRITE_FLUSH {
	    local($tty) = @_;
	    eval " &tty_write_flush(($tty))";
	}';
    }
}
1;
