if (!defined &__LINUX_UFS_FS_H) {
    eval 'sub __LINUX_UFS_FS_H {1;}';
    require 'linux/types.ph';
    require 'linux/kernel.ph';
    require 'linux/time.ph';
    require 'linux/stat.ph';
    eval 'sub UFS_BBLOCK {0;}';
    eval 'sub UFS_BBSIZE {8192;}';
    eval 'sub UFS_SBLOCK {8192;}';
    eval 'sub UFS_SBSIZE {8192;}';
    eval 'sub UFS_MAGIC {0x00011954;}';
    eval 'sub UFS_FSIZE {1024;}';
    eval 'sub UFS_BSIZE {8192;}';
    eval 'sub UFS_NDADDR {12;}';
    eval 'sub UFS_NINDIR {3;}';
    eval 'sub UFS_IND_BLOCK {( &UFS_NDADDR + 0);}';
    eval 'sub UFS_DIND_BLOCK {( &UFS_NDADDR + 1);}';
    eval 'sub UFS_TIND_BLOCK {( &UFS_NDADDR + 2);}';
    eval 'sub UFS_ROOTINO {2;}';
    eval 'sub UFS_USEEFT {(( &__u16)65535);}';
    eval 'sub UFS_FSOK {0x7c269d38;}';
    eval 'sub UFS_FSACTIVE {(0x00);}';
    eval 'sub UFS_FSCLEAN {(0x01);}';
    eval 'sub UFS_FSSTABLE {(0x02);}';
    eval 'sub UFS_FSBAD {(0xff);}';
    eval 'sub UFS_DEBUG {0x00000001;}';
    eval 'sub UFS_DEBUG_INODE {0x00000002;}';
    eval 'sub UFS_DEBUG_NAMEI {0x00000004;}';
    eval 'sub UFS_DEBUG_LINKS {0x00000008;}';
    eval 'sub UFS_ADDR_PER_BLOCK {
        local($sb) = @_;
        eval "(($sb)-> &u. &ufs_sb. &s_bsize >> 2)";
    }';
    eval 'sub UFS_ADDR_PER_BLOCK_BITS {
        local($sb) = @_;
        eval "(($sb)-> &u. &ufs_sb. &s_bshift - 2)";
    }';
    eval 'sub ufs_ino_ok {
        local($inode) = @_;
        eval "(($inode-> &i_ino < 2) && ($inode-> &i_ino > ($inode-> &i_sb-> &u. &ufs_sb. &s_ncg * $inode-> &i_sb-> &u. &ufs_sb. &s_ipg - 1)))";
    }';
    eval 'sub ufs_cgstart {
        local($sb, $cg) = @_;
        eval "((($sb)-> &u. &ufs_sb. &s_fpg * ($cg)) + ($sb)-> &u. &ufs_sb. &s_cgoffset * (($cg) & ~(($sb)-> &u. &ufs_sb. &s_cgmask)))";
    }';
    eval 'sub ufs_cgimin {
        local($sb, $cg) = @_;
        eval "( &ufs_cgstart(($sb), ($cg)) + ($sb)-> &u. &ufs_sb. &s_iblkno)";
    }';
    eval 'sub ufs_cgdmin {
        local($sb, $cg) = @_;
        eval "( &ufs_cgstart(($sb), ($cg)) + ($sb)-> &u. &ufs_sb. &s_dblkno)";
    }';
    eval 'sub ufs_ino2cg {
        local($inode) = @_;
        eval "(($inode)-> &i_ino/($inode)-> &i_sb-> &u. &ufs_sb. &s_ipg)";
    }';
    eval 'sub UFS_MAXNAMLEN {255;}';
    eval 'sub ufs_lbn {
        local($sb, $block) = @_;
        eval "(($block) >> ($sb)-> &u. &ufs_sb. &s_lshift)";
    }';
    eval 'sub ufs_boff {
        local($sb, $block) = @_;
        eval "(($block) & ~(($sb)-> &u. &ufs_sb. &s_lmask))";
    }';
    eval 'sub ufs_dbn {
        local($sb, $block, $boff) = @_;
        eval "(($block) +  &ufs_boff(($sb), ($boff)))";
    }';
    eval 'sub MAXMNTLEN {512;}';
    eval 'sub MAXCSBUFS {32;}';
    if (defined &__KERNEL__) {
    }
}
1;
