if (!defined &_TCL) {
    eval 'sub _TCL {1;}';
    eval 'sub TCL_MAJOR_VERSION {7;}';
    eval 'sub TCL_MINOR_VERSION {6;}';
    eval 'sub TCL_RELEASE_LEVEL {2;}';
    eval 'sub TCL_RELEASE_SERIAL {0;}';
    eval 'sub TCL_VERSION {"7.6";}';
    eval 'sub TCL_PATCH_LEVEL {"7.6";}';
    if (!defined &__WIN32__) {
	if (defined( &_WIN32) || defined( &WIN32)) {
	    eval 'sub __WIN32__ {1;}';
	}
    }
    if (defined &__WIN32__) {
	if (!defined &STRICT) {
	    eval 'sub STRICT {1;}';
	}
	if (!defined &USE_PROTOTYPE) {
	    eval 'sub USE_PROTOTYPE {1;}';
	}
	if (!defined &HAS_STDARG) {
	    eval 'sub HAS_STDARG {1;}';
	}
	if (!defined &USE_PROTOTYPE) {
	    eval 'sub USE_PROTOTYPE {1;}';
	}
	if (!defined &USE_TCLALLOC) {
	    eval 'sub USE_TCLALLOC {1;}';
	}
	if (!defined &STRINGIFY) {
	    eval 'sub STRINGIFY {
	        local($x) = @_;
	        eval " &STRINGIFY1($x)";
	    }';
	    eval 'sub STRINGIFY1 {
	        local($x) = @_;
	        eval "$x";
	    }';
	}
    }
    if (defined &MAC_TCL) {
	if (!defined &HAS_STDARG) {
	    eval 'sub HAS_STDARG {1;}';
	}
	if (!defined &USE_TCLALLOC) {
	    eval 'sub USE_TCLALLOC {1;}';
	}
	if (!defined &NO_STRERROR) {
	    eval 'sub NO_STRERROR {1;}';
	}
    }
    if (!defined &RESOURCE_INCLUDED) {
	if (!defined &BUFSIZ) {
	    require 'stdio.ph';
	}
	if (defined( &__STDC__) || defined( &HAS_STDARG)) {
	    eval 'sub TCL_VARARGS {
	        local($type, $name) = @_;
	        eval "($type $name, ...)";
	    }';
	    eval 'sub TCL_VARARGS_DEF {
	        local($type, $name) = @_;
	        eval "($type $name, ...)";
	    }';
	    eval 'sub TCL_VARARGS_START {
	        local($type, $name, $list) = @_;
	        eval "( &va_start($list, $name), $name)";
	    }';
	}
	else {
	    if (defined &__cplusplus) {
		eval 'sub TCL_VARARGS {
		    local($type, $name) = @_;
		    eval "($type $name, ...)";
		}';
		eval 'sub TCL_VARARGS_DEF {
		    local($type, $name) = @_;
		    eval "($type  &va_alist, ...)";
		}';
	    }
	    else {
		eval 'sub TCL_VARARGS {
		    local($type, $name) = @_;
		    eval "()";
		}';
		eval 'sub TCL_VARARGS_DEF {
		    local($type, $name) = @_;
		    eval "( &va_alist)";
		}';
	    }
	    eval 'sub TCL_VARARGS_START {
	        local($type, $name, $list) = @_;
	        eval "( &va_start($list),  &va_arg($list, $type))";
	    }';
	}
	if (((defined( &__STDC__) || defined( &SABER)) && !defined( &NO_PROTOTYPE)) || defined( &__cplusplus) || defined( &USE_PROTOTYPE)) {
	    eval 'sub _USING_PROTOTYPES_ {1;}';
	    eval 'sub _ANSI_ARGS_ {
	        local($x) = @_;
	        eval "$x";
	    }';
	    eval 'sub CONST { &const;}';
	}
	else {
	    eval 'sub _ANSI_ARGS_ {
	        local($x) = @_;
	        eval "()";
	    }';
	    eval 'sub CONST {1;}';
	}
	if (defined &__cplusplus) {
	    eval 'sub EXTERN { &extern "C";}';
	}
	else {
	    eval 'sub EXTERN { &extern;}';
	}
	if (!defined &__WIN32__) {
	    if (!defined &VOID) {
		if (defined &__STDC__) {
		    eval 'sub VOID { &void;}';
		}
		else {
		    eval 'sub VOID {\'char\';}';
		}
	    }
	}
	else {
	    if (!defined &VOID) {
		eval 'sub VOID { &void;}';
	    }
	}
	if (!defined &NULL) {
	    eval 'sub NULL {0;}';
	}
	if (!defined &_CLIENTDATA) {
	    if (defined( &__STDC__) || defined( &__cplusplus)) {
	    }
	    else {
	    }
	    eval 'sub _CLIENTDATA {1;}';
	}
	eval 'sub TCL_OK {0;}';
	eval 'sub TCL_ERROR {1;}';
	eval 'sub TCL_RETURN {2;}';
	eval 'sub TCL_BREAK {3;}';
	eval 'sub TCL_CONTINUE {4;}';
	eval 'sub TCL_RESULT_SIZE {200;}';
	eval 'sub TCL_DSTRING_STATIC_SIZE {200;}';
	eval 'sub Tcl_DStringLength {
	    local($dsPtr) = @_;
	    eval "(($dsPtr)-> &length)";
	}';
	eval 'sub Tcl_DStringValue {
	    local($dsPtr) = @_;
	    eval "(($dsPtr)-> &string)";
	}';
	eval 'sub Tcl_DStringTrunc { &Tcl_DStringSetLength;}';
	eval 'sub TCL_MAX_PREC {17;}';
	eval 'sub TCL_DOUBLE_SPACE {( &TCL_MAX_PREC+10);}';
	eval 'sub TCL_DONT_USE_BRACES {1;}';
	eval 'sub TCL_NO_EVAL {0x10000;}';
	eval 'sub TCL_EVAL_GLOBAL {0x20000;}';
	eval 'sub TCL_VOLATILE {(( &Tcl_FreeProc *) 1);}';
	eval 'sub TCL_STATIC {(( &Tcl_FreeProc *) 0);}';
	eval 'sub TCL_DYNAMIC {(( &Tcl_FreeProc *) 3);}';
	eval 'sub TCL_GLOBAL_ONLY {1;}';
	eval 'sub TCL_APPEND_VALUE {2;}';
	eval 'sub TCL_LIST_ELEMENT {4;}';
	eval 'sub TCL_TRACE_READS {0x10;}';
	eval 'sub TCL_TRACE_WRITES {0x20;}';
	eval 'sub TCL_TRACE_UNSETS {0x40;}';
	eval 'sub TCL_TRACE_DESTROYED {0x80;}';
	eval 'sub TCL_INTERP_DESTROYED {0x100;}';
	eval 'sub TCL_LEAVE_ERR_MSG {0x200;}';
	eval 'sub TCL_LINK_INT {1;}';
	eval 'sub TCL_LINK_DOUBLE {2;}';
	eval 'sub TCL_LINK_BOOLEAN {3;}';
	eval 'sub TCL_LINK_STRING {4;}';
	eval 'sub TCL_LINK_READ_ONLY {0x80;}';
	if (defined &TCL_MEM_DEBUG) {
	    eval 'sub Tcl_Alloc {
	        local($x) = @_;
	        eval " &Tcl_DbCkalloc($x,  &__FILE__,  &__LINE__)";
	    }';
	    eval 'sub Tcl_Free {
	        local($x) = @_;
	        eval " &Tcl_DbCkfree($x,  &__FILE__,  &__LINE__)";
	    }';
	    eval 'sub Tcl_Realloc {
	        local($x,$y) = @_;
	        eval " &Tcl_DbCkrealloc(($x), ($y), &__FILE__,  &__LINE__)";
	    }';
	    eval 'sub ckalloc {
	        local($x) = @_;
	        eval " &Tcl_DbCkalloc($x,  &__FILE__,  &__LINE__)";
	    }';
	    eval 'sub ckfree {
	        local($x) = @_;
	        eval " &Tcl_DbCkfree($x,  &__FILE__,  &__LINE__)";
	    }';
	    eval 'sub ckrealloc {
	        local($x,$y) = @_;
	        eval " &Tcl_DbCkrealloc(($x), ($y), &__FILE__,  &__LINE__)";
	    }';
	}
	else {
	    if ((defined(&USE_TCLALLOC) ? &USE_TCLALLOC : 0)) {
		eval 'sub ckalloc {
		    local($x) = @_;
		    eval " &Tcl_Alloc($x)";
		}';
		eval 'sub ckfree {
		    local($x) = @_;
		    eval " &Tcl_Free($x)";
		}';
		eval 'sub ckrealloc {
		    local($x,$y) = @_;
		    eval " &Tcl_Realloc($x,$y)";
		}';
	    }
	    else {
		eval 'sub ckalloc {
		    local($x) = @_;
		    eval " &malloc($x)";
		}';
		eval 'sub ckfree {
		    local($x) = @_;
		    eval " &free($x)";
		}';
		eval 'sub ckrealloc {
		    local($x,$y) = @_;
		    eval " &realloc($x,$y)";
		}';
	    }
	    eval 'sub Tcl_DumpActiveMemory {
	        local($x) = @_;
	        eval "";
	    }';
	    eval 'sub Tcl_ValidateAllMemory {
	        local($x,$y) = @_;
	        eval "";
	    }';
	}
	eval 'sub Tcl_FreeResult {
	    local($interp) = @_;
	    eval " &if (($interp)-> &freeProc != 0) {  &if ((($interp)-> &freeProc ==  &TCL_DYNAMIC) || (($interp)-> &freeProc == ( &Tcl_FreeProc *)  &free)) {  &ckfree(($interp)-> &result); }  &else { (*($interp)-> &freeProc)(($interp)-> &result); } ($interp)-> &freeProc = 0; }";
	}';
	if (defined &__cplusplus) {
	}
	eval 'sub TCL_SMALL_HASH_TABLE {4;}';
	eval 'sub TCL_STRING_KEYS {0;}';
	eval 'sub TCL_ONE_WORD_KEYS {1;}';
	eval 'sub Tcl_GetHashValue {
	    local($h) = @_;
	    eval "(($h)-> &clientData)";
	}';
	eval 'sub Tcl_SetHashValue {
	    local($h, $value) = @_;
	    eval "(($h)-> &clientData = ( &ClientData) ($value))";
	}';
	eval 'sub Tcl_GetHashKey {
	    local($tablePtr, $h) = @_;
	    eval "( ((($tablePtr)-> &keyType ==  &TCL_ONE_WORD_KEYS) ? ($h)-> &key. &oneWordValue : ($h)-> &key. &string))";
	}';
	eval 'sub Tcl_FindHashEntry {
	    local($tablePtr, $key) = @_;
	    eval "(*(($tablePtr)-> &findProc))($tablePtr, $key)";
	}';
	eval 'sub Tcl_CreateHashEntry {
	    local($tablePtr, $key, $newPtr) = @_;
	    eval "(*(($tablePtr)-> &createProc))($tablePtr, $key, $newPtr)";
	}';
	eval 'sub TCL_DONT_WAIT {(1<<1);}';
	eval 'sub TCL_WINDOW_EVENTS {(1<<2);}';
	eval 'sub TCL_FILE_EVENTS {(1<<3);}';
	eval 'sub TCL_TIMER_EVENTS {(1<<4);}';
	eval 'sub TCL_IDLE_EVENTS {(1<<5);}';
	eval 'sub TCL_ALL_EVENTS {(~ &TCL_DONT_WAIT);}';
	eval 'sub TCL_READABLE {(1<<1);}';
	eval 'sub TCL_WRITABLE {(1<<2);}';
	eval 'sub TCL_EXCEPTION {(1<<3);}';
	eval 'sub TCL_STDIN {(1<<1);}';
	eval 'sub TCL_STDOUT {(1<<2);}';
	eval 'sub TCL_STDERR {(1<<3);}';
	eval 'sub TCL_ENFORCE_MODE {(1<<4);}';
	eval 'sub TCL_MODE_BLOCKING {0;}';
	eval 'sub TCL_MODE_NONBLOCKING {1;}';
	eval 'sub TCL_UNIX_FD {1;}';
	eval 'sub TCL_MAC_FILE {2;}';
	eval 'sub TCL_MAC_SOCKET {3;}';
	eval 'sub TCL_WIN_PIPE {4;}';
	eval 'sub TCL_WIN_FILE {5;}';
	eval 'sub TCL_WIN_SOCKET {6;}';
	eval 'sub TCL_WIN_CONSOLE {7;}';
	eval 'sub TCL_WIN32S_PIPE {8;}';
	eval 'sub Tcl_Ckalloc { &Tcl_Alloc;}';
	eval 'sub Tcl_Ckfree { &Tcl_Free;}';
	eval 'sub Tcl_Ckrealloc { &Tcl_Realloc;}';
	eval 'sub Tcl_Return { &Tcl_SetResult;}';
	eval 'sub Tcl_TildeSubst { &Tcl_TranslateFileName;}';
    }
}
1;
